HDU 2588 GCD GCD问题总结

2024-05-03 19:08
文章标签 问题 总结 hdu gcd 2588

本文主要是介绍HDU 2588 GCD GCD问题总结,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

                                                                                                             GCD(一)

题目:

 The greatest common divisor GCD(a,b) of two positive integers a and b,sometimes written (a,b),is the largest divisor common to a and b,For example,(1,2)=1,(12,18)=6.
(a,b) can be easily found by the Euclidean algorithm. Now Carp is considering a little more difficult problem:
Given integers N and M, how many integer X satisfies 1<=X<=N and (X,N)>=M.

   求满足题目要求的x个数。

算法:

   直接筛选会超时,根据题目给出的不等式特点GCD(x,N) >= M 可以知道满足题目要求的一定是N的因子而且必须大于等于M(想想为什么?解体关键)。所以,只要枚举N的大于等于M的因子就可以了。因为,在10^9内最多的因子数不超过30个。所以,总时间是O(30*loglogn)接近常数。

 

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;typedef __int64 LL;
const int MOD = 1000000007;int euler_phi(int n){int k = (int)sqrt(n + 0.5);int ans = n;for(int i = 2;i <= k;++i) if(0 == n % i){ans = ans / i * (i - 1);while(0 == n % i) n /= i;}if(n > 1) ans = ans / n * (n - 1);return ans;
}LL getFact(int n,int m){LL res = 0;int k = sqrt(n + 0.5);int tmp;for(int i = 1;i <= k;++i){if(0 == n % i){tmp = n / i;if(i >= m) res += euler_phi(n / i);if(tmp >= m && i != tmp) res += euler_phi(n / tmp);}}return res;
}int main()
{int T,n,m;scanf("%d",&T);while(T--){scanf("%d%d",&n,&m);if(n == 1 && m == 1){puts("1");continue;}printf("%I64d\n",getFact(n,m));}return 0;
}


 

  

                                GCD(二)

题目:

   给你一个数N,使得在1~N之间能够找到x使得x满足gcd( x ,  N  ) >= M,求解gcd(x,N)的和。

算法:

  由上题的知识可以知道,1...N的互质个数为欧拉函数值且其gcd只能是N的因子。所以,对于N = x * y。我们只要

求出x在y内的互质个数就好了,结果乘以x就是gcd = x的和了.

证明:

   SUM(gcd = x ) = 1*x + 2*x + 3*x ..... y*x

  所以,当gcd = x的时候只要求出y的欧拉函数值就好了。

 

而一个数的因子又可以在sqrt(N)内求出。

 

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;typedef long long LL;int euler_phi(int n){int m = sqrt(n + 0.5);int ans = n;for(int i = 2;i <= m;++i) if(0 == n % i){ans = ans / i * (i - 1);while(0 == n % i) n /= i;}if(n > 1) ans = ans / n * (n - 1);return ans;
}LL solve(int n,int m){LL res = 0;int k = sqrt(n + 0.5);for(int i = 1;i <= k;++i){if(0 == n % i){if(i >= m)res += i * euler_phi(n / i);if(i != n / i && n / i >= m)res += n / i * euler_phi(i);}}return res;
}int main()
{int n,m;while(~scanf("%d%d",&n,&m)){printf("%lld\n",solve(n,m));}return 0;
}


 

                                                                                                  GCD(三)

 

题目:

    The greatest common divisor GCD(a,b) of two positive integers a and b,sometimes written (a,b),is the largest divisor common to a and b,For example,(1,2)=1,(12,18)=6.
(a,b) can be easily found by the Euclidean algorithm. Now Carp is considering a little more difficult problem:
Given integers N and M,please answer sum of  X satisfies 1<=X<=N and (X,N)>=M.

 

算法:

   跟GCD(一)不同的是这题求得是满足gcd(x,n) >= m ,x的和。而由欧拉函数中的一个定理可以知道

 

所以,只要SUM(n = x * y) = y*α(y) / 2 * x 

因为要的是x的和,而我们是在把X先进行X / x处理的所以最后要在乘回上x得到原值。

 

 
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;typedef long long LL;
const int MOD = 1000000007;int euler_phi(int n){int k = (int)sqrt(n + 0.5);int ans = n;for(int i = 2;i <= k;++i) if(0 == n % i){ans = ans / i * (i - 1);while(0 == n % i) n /= i;}if(n > 1) ans = ans / n * (n - 1);return ans;
}LL getFact(int n,int m){LL res = 0;int k = sqrt(n + 0.5);LL tmp;for(int i = 1;i <= k;++i){if(0 == n % i){tmp = n / i;if(i >= m){LL t1 = tmp * euler_phi(tmp) / 2 % MOD;t1 = t1 ? t1 : 1;res = (res + t1 * i) % MOD;}if(tmp >= m && i != tmp) {LL t1 = i * euler_phi(i) / 2 % MOD;t1 = t1 ? t1 : 1;res = (res + t1 * tmp) % MOD;}}}return res >= MOD ? res%MOD : res;
}int main()
{int T,n,m;scanf("%d",&T);while(T--){scanf("%d%d",&n,&m);printf("%lld\n",getFact(n,m));}return 0;
}

 

这篇关于HDU 2588 GCD GCD问题总结的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/957430

相关文章

HarmonyOS学习(七)——UI(五)常用布局总结

自适应布局 1.1、线性布局(LinearLayout) 通过线性容器Row和Column实现线性布局。Column容器内的子组件按照垂直方向排列,Row组件中的子组件按照水平方向排列。 属性说明space通过space参数设置主轴上子组件的间距,达到各子组件在排列上的等间距效果alignItems设置子组件在交叉轴上的对齐方式,且在各类尺寸屏幕上表现一致,其中交叉轴为垂直时,取值为Vert

学习hash总结

2014/1/29/   最近刚开始学hash,名字很陌生,但是hash的思想却很熟悉,以前早就做过此类的题,但是不知道这就是hash思想而已,说白了hash就是一个映射,往往灵活利用数组的下标来实现算法,hash的作用:1、判重;2、统计次数;

好题——hdu2522(小数问题:求1/n的第一个循环节)

好喜欢这题,第一次做小数问题,一开始真心没思路,然后参考了网上的一些资料。 知识点***********************************无限不循环小数即无理数,不能写作两整数之比*****************************(一开始没想到,小学没学好) 此题1/n肯定是一个有限循环小数,了解这些后就能做此题了。 按照除法的机制,用一个函数表示出来就可以了,代码如下

hdu1043(八数码问题,广搜 + hash(实现状态压缩) )

利用康拓展开将一个排列映射成一个自然数,然后就变成了普通的广搜题。 #include<iostream>#include<algorithm>#include<string>#include<stack>#include<queue>#include<map>#include<stdio.h>#include<stdlib.h>#include<ctype.h>#inclu

usaco 1.3 Mixing Milk (结构体排序 qsort) and hdu 2020(sort)

到了这题学会了结构体排序 于是回去修改了 1.2 milking cows 的算法~ 结构体排序核心: 1.结构体定义 struct Milk{int price;int milks;}milk[5000]; 2.自定义的比较函数,若返回值为正,qsort 函数判定a>b ;为负,a<b;为0,a==b; int milkcmp(const void *va,c

购买磨轮平衡机时应该注意什么问题和技巧

在购买磨轮平衡机时,您应该注意以下几个关键点: 平衡精度 平衡精度是衡量平衡机性能的核心指标,直接影响到不平衡量的检测与校准的准确性,从而决定磨轮的振动和噪声水平。高精度的平衡机能显著减少振动和噪声,提高磨削加工的精度。 转速范围 宽广的转速范围意味着平衡机能够处理更多种类的磨轮,适应不同的工作条件和规格要求。 振动监测能力 振动监测能力是评估平衡机性能的重要因素。通过传感器实时监

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2093 考试排名(sscanf)

模拟题。 直接从教程里拉解析。 因为表格里的数据格式不统一。有时候有"()",有时候又没有。而它也不会给我们提示。 这种情况下,就只能它它们统一看作字符串来处理了。现在就请出我们的主角sscanf()! sscanf 语法: #include int sscanf( const char *buffer, const char *format, ... ); 函数sscanf()和

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :